<?php
/*
Plugin Name: OAuth Provider
Version: 0.4.2
Plugin URI: http://wordpress.org/extend/plugins/oauth-provider/
Description: A plugin to allow WordPress to use an OAuth authenticator.
Author: wokamoto
Author URI: http://dogmap.jp/
Text Domain: oauth-provider
Domain Path: /languages/

License:
 Released under the GPL license
  http://www.gnu.org/copyleft/gpl.html
  Copyright 2011 wokamoto (email : wokamoto1973@gmail.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/
if (!class_exists('WP_OAuthProvider'))
	require_once ('class-oauth-provider.php');

//**************************************************************************************
// Add new oauth method
//**************************************************************************************
if (!function_exists('add_oauth_method')) {
	function add_oauth_method( $name, $method ) {
		global $oauth_provider;
		if (!isset($oauth_provider))
			$oauth_provider = new WP_OAuthProvider();
		$oauth_provider->add_method($name, $method);
	}
}

//**************************************************************************************
// Remove oauth method
//**************************************************************************************
if (!function_exists('remove_oauth_method')) {
	function remove_oauth_method( $name ) {
		global $oauth_provider;
		if (!isset($oauth_provider))
			$oauth_provider = new WP_OAuthProvider();
		$oauth_provider->remove_method($name);
	}
}

//**************************************************************************************
// Go! Go! Go!
//**************************************************************************************
global $oauth_provider;

if (!isset($oauth_provider))
	$oauth_provider = new WP_OAuthProvider();
//$oauth_provider->consumer_pin_enabled = TRUE;

// Add Method Sample
add_oauth_method('sayHello', create_function('$request, $userid, $username', 'return array("message" => "Hello {$username}!");'));
?>